## freecad 0.19.1+dfsg1

=== src/3rdParty/CMakeLists.txt ===
# Build SalomeMesh for all Platforms since heavily patched
if (BUILD_SMESH AND NOT FREECAD_USE_EXTERNAL_SMESH)
    add_subdirectory(salomesmesh)
endif()

add_subdirectory(lazy_loader)

=== src/Base/CMakeLists.txt ===
if(WIN32)
    add_definitions(-DFCBase)
    add_definitions(-DPYCXX_DLL)
    add_definitions(-DBOOST_DYN_LINK)
    add_definitions(-DZIPIOS_UTF8)
endif(WIN32)

include_directories(
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${XercesC_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${PYCXX_INCLUDE_DIR}
)

if(MSVC)
    set(FreeCADBase_LIBS
        ${Boost_LIBRARIES}
        ${XercesC_LIBRARIES}
        ${ZLIB_LIBRARIES}
        debug MSVCRTD.LIB
        debug MSVCPRTD.LIB
        optimized MSVCRT.LIB
        optimized MSVCPRT.LIB
        Rpcrt4.lib
        version.lib
    )

    #Universal C runtime introduced in VS 2015 (cl version 19)
    if (NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19"))
        list(APPEND FreeCADBase_LIBS
            debug vcruntimed.lib
            debug ucrtd.lib
            debug concrtd.lib
            optimized vcruntime.lib
            optimized ucrt.lib
            optimized concrt.lib
        )
    endif()
elseif(MINGW)
    set(FreeCADBase_LIBS
        ${XercesC_LIBRARIES}
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
        Rpcrt4.lib
    )
else(MSVC)
    set(FreeCADBase_LIBS
        ${XercesC_LIBRARIES}
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
    )
endif(MSVC)

if (BUILD_QT5)
    include_directories(
        ${Qt5Core_INCLUDE_DIRS}
    )
    list(APPEND FreeCADBase_LIBS ${Qt5Core_LIBRARIES})
else()
    include_directories(
        ${QT_QTCORE_INCLUDE_DIR}
    )
    list(APPEND FreeCADBase_LIBS ${QT_QTCORE_LIBRARY})
endif()

if (BUILD_DYNAMIC_LINK_PYTHON)
    list(APPEND FreeCADBase_LIBS ${PYTHON_LIBRARIES})
endif (BUILD_DYNAMIC_LINK_PYTHON)

# needed for OpenSUSE
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    list(APPEND FreeCADBase_LIBS -lutil -ldl)
endif()

generate_from_xml(TypePy)
generate_from_xml(BaseClassPy)
generate_from_xml(BoundBoxPy)
generate_from_xml(CoordinateSystemPy)
generate_from_xml(PersistencePy)
generate_from_xml(VectorPy)
generate_from_xml(MatrixPy)
generate_from_xml(RotationPy)
generate_from_xml(PlacementPy)
generate_from_xml(AxisPy)
generate_from_xml(UnitPy)
generate_from_xml(QuantityPy)
generate_from_any(Parameter.xsd Parameter.inl xmlSchemeString)

if(SWIG_FOUND)
    # Create the file swigpyrun.hh and then compare with the file swigpyrun.h.
    # If the files are different or if swigpyrun.h doesn't exist then copy swigpyrun.hh.
    # This is to avoid to having to build the target each time cmake configure is executed.
    execute_process(COMMAND ${SWIG_EXECUTABLE} -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.hh)

    fc_copy_file_if_different(
        "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.hh"
        "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
    )
    add_definitions(-DHAVE_SWIG=1)
endif(SWIG_FOUND)

if (EXISTS ${CMAKE_SOURCE_DIR}/src/zipios++ AND NOT FREECAD_USE_EXTERNAL_ZIPIOS)
SET(zipios_SRCS
    ../zipios++/backbuffer.h
    ../zipios++/basicentry.cpp
    ../zipios++/basicentry.h
    ../zipios++/collcoll.cpp
    ../zipios++/collcoll.h
    ../zipios++/deflateoutputstreambuf.cpp
    ../zipios++/deflateoutputstreambuf.h
    ../zipios++/dircoll.cpp
    ../zipios++/dircoll.h
    ../zipios++/directory.cpp
    ../zipios++/directory.h
    ../zipios++/fcoll.cpp
    ../zipios++/fcoll.h
    ../zipios++/fcollexceptions.cpp
    ../zipios++/fcollexceptions.h
    ../zipios++/fileentry.cpp
    ../zipios++/fileentry.h
    ../zipios++/filepath.cpp
    ../zipios++/filepath.h
    ../zipios++/filterinputstreambuf.cpp
    ../zipios++/filterinputstreambuf.h
    ../zipios++/filteroutputstreambuf.cpp
    ../zipios++/filteroutputstreambuf.h
    ../zipios++/gzipoutputstream.cpp
    ../zipios++/gzipoutputstream.h
    ../zipios++/gzipoutputstreambuf.cpp
    ../zipios++/gzipoutputstreambuf.h
    ../zipios++/inflateinputstreambuf.cpp
    ../zipios++/inflateinputstreambuf.h
    ../zipios++/meta-iostreams.h
    ../zipios++/outputstringstream.h
    ../zipios++/simplesmartptr.h
    ../zipios++/virtualseeker.h
    ../zipios++/zipfile.cpp
    ../zipios++/zipfile.h
    ../zipios++/ziphead.cpp
    ../zipios++/ziphead.h
    ../zipios++/zipheadio.cpp
    ../zipios++/zipheadio.h
    ../zipios++/zipinputstream.cpp
    ../zipios++/zipinputstream.h
    ../zipios++/zipinputstreambuf.cpp
    ../zipios++/zipinputstreambuf.h
    ../zipios++/zipios_common.h
    ../zipios++/zipios-config.h
    ../zipios++/zipios_defs.h
    ../zipios++/zipoutputstreambuf.cpp
    ../zipios++/zipoutputstreambuf.h
    ../zipios++/zipoutputstream.cpp
    ../zipios++/zipoutputstream.h
)
SOURCE_GROUP("zipios" FILES ${zipios_SRCS})
endif ()

SOURCE_GROUP("pycxx" FILES ${PYCXX_SOURCES})

SET(FreeCADBase_XML_SRCS
    AxisPy.xml
    BaseClassPy.xml
    BoundBoxPy.xml
    CoordinateSystemPy.xml
    MatrixPy.xml
    PersistencePy.xml
    PlacementPy.xml
    RotationPy.xml
    VectorPy.xml
    QuantityPy.xml
    TypePy.xml
    UnitPy.xml
)
SOURCE_GROUP("XML" FILES ${FreeCADBase_XML_SRCS})

set(FreeCADBase_MOC_HDRS
    Debugger.h
    FutureWatcherProgress.h
)

fc_wrap_cpp(FreeCADBase_MOC_SRCS ${FreeCADBase_MOC_HDRS})

SET(FreeCADBase_UNITAPI_SRCS
    UnitsApi.cpp
    UnitsApiPy.cpp
    UnitsApi.h
    UnitsSchema.h
    UnitsSchema.cpp
    UnitsSchemaInternal.h
    UnitsSchemaInternal.cpp
    UnitsSchemaMKS.h
    UnitsSchemaMKS.cpp
    UnitsSchemaImperial1.h
    UnitsSchemaImperial1.cpp
    UnitsSchemaCentimeters.h
    UnitsSchemaCentimeters.cpp
    UnitsSchemaMmMin.h
    UnitsSchemaMmMin.cpp
    UnitsSchemaFemMilliMeterNewton.h
    UnitsSchemaFemMilliMeterNewton.cpp
    Quantity.h
    Quantity.cpp
    QuantityPyImp.cpp
    QuantityParser.l
    QuantityParser.y
    Unit.h
    Unit.cpp
    UnitPyImp.cpp
    
)
SOURCE_GROUP("Units" FILES ${FreeCADBase_UNITAPI_SRCS})

if(PYTHON_VERSION_MAJOR LESS 3)
SET(SWIG_SRCS
    swigpyrun_1.3.25.cpp
    swigpyrun_1.3.33.cpp
    swigpyrun_1.3.36.cpp
    swigpyrun_1.3.38.cpp
    swigpyrun_1.3.40.cpp
    swigpyrun.cpp
)
else(PYTHON_VERSION_MAJOR LESS 3)
SET(SWIG_SRCS
    swigpyrun.cpp
)
endif(PYTHON_VERSION_MAJOR LESS 3)

SET(FreeCADBase_CPP_SRCS
    Axis.cpp
    AxisPyImp.cpp
    Base64.cpp
    BaseClass.cpp
    BaseClassPyImp.cpp
    BoundBoxPyImp.cpp
    Builder3D.cpp
    Console.cpp
    CoordinateSystem.cpp
    CoordinateSystemPyImp.cpp
    Debugger.cpp
    DualQuaternion.cpp
    Exception.cpp
    ExceptionFactory.cpp
    Factory.cpp
    FileInfo.cpp
    FileTemplate.cpp
    FutureWatcherProgress.cpp
    gzstream.cpp
    gzstream.h
    GeometryPyCXX.cpp
    Handle.cpp
    InputSource.cpp
    Interpreter.cpp
    Matrix.cpp
    MatrixPyImp.cpp
    MemDebug.cpp
    Parameter.xsd
    Parameter.cpp
    ParameterPy.cpp
    Persistence.cpp
    PersistencePyImp.cpp
    Placement.cpp
    PlacementPyImp.cpp
    PyExport.cpp
    PyObjectBase.cpp
    Reader.cpp
    Rotation.cpp
    RotationPyImp.cpp
    Sequencer.cpp
    Stream.cpp
    Swap.cpp
    ${SWIG_SRCS}
    TimeInfo.cpp
    Tools.cpp
    Tools2D.cpp
    Translate.cpp
    Type.cpp
    TypePyImp.cpp
    Uuid.cpp
    Vector3D.cpp
    VectorPyImp.cpp
    ViewProj.cpp
    Writer.cpp
    XMLTools.cpp
)

if(PYTHON_VERSION_MAJOR LESS 3)
SET(SWIG_HEADERS
    swigpyrun_1.3.25.h
    swigpyrun_1.3.33.h
    swigpyrun_1.3.36.h
    swigpyrun_1.3.38.h
    swigpyrun_1.3.40.h
    swigpyrun.inl
)
else(PYTHON_VERSION_MAJOR LESS 3)
SET(SWIG_HEADERS
    swigpyrun.inl
)
endif(PYTHON_VERSION_MAJOR LESS 3)

SET(FreeCADBase_HPP_SRCS
    Axis.h
    Base64.h
    BaseClass.h
    BoundBox.h
    Builder3D.h
    Console.h
    Converter.h
    CoordinateSystem.h
    Debugger.h
    DualNumber.h
    DualQuaternion.h
    Exception.h
    ExceptionFactory.h
    Factory.h
    FileInfo.h
    FileTemplate.h
    FutureWatcherProgress.h
    fdstream.hpp
    gzstream.h
    GeometryPyCXX.h
    Handle.h
    InputSource.h
    Interpreter.h
    Matrix.h
    MemDebug.h
    Observer.h
    Parameter.h
    Persistence.h
    Placement.h
    PyExport.h
    PyObjectBase.h
    Reader.h
    Rotation.h
    Sequencer.h
    StdStlTools.h
    Stream.h
    Swap.h
    ${SWIG_HEADERS}
    TimeInfo.h
    Tools.h
    Tools2D.h
    Translate.h
    Type.h
    Uuid.h
    Vector3D.h
    ViewProj.h
    Writer.h
    XMLTools.h
)

SET(FreeCADBase_SRCS
    ${PYCXX_SOURCES}
    ${FreeCADBase_CPP_SRCS}
    ${FreeCADBase_HPP_SRCS}
    ${FreeCADBase_XML_SRCS}
    ${FreeCADBase_UNITAPI_SRCS}
    PyTools.c
    PyTools.h
    PreCompiled.cpp
    PreCompiled.h
)

IF (MSVC)
    SET(FreeCADBase_SRCS
        ${FreeCADBase_SRCS}
        StackWalker.cpp
        StackWalker.h
)
ENDIF(MSVC)

# Use external zipios++ if specified.
if(FREECAD_USE_EXTERNAL_ZIPIOS)
    find_library(ZIPIOS_LIBRARY zipios)
    find_path(ZIPIOS_INCLUDES zipios++/zipios-config.h)
    if(ZIPIOS_LIBRARY)
        message(STATUS "Found zipios++: ${ZIPIOS}")
    endif()
    if(ZIPIOS_INCLUDES)
        message(STATUS "Found zipios++ headers.")
    endif()
    if(ZIPIOS_LIBRARY AND ZIPIOS_INCLUDES)
        list(APPEND FreeCADBase_LIBS ${ZIPIOS_LIBRARY})
        include_directories(${ZIPIOS_INCLUDES})
    else()
        message(FATAL_ERROR "Using external zipios++ was specified but was not found.")
    endif()
else(FREECAD_USE_EXTERNAL_ZIPIOS)
    list(APPEND FreeCADBase_SRCS ${zipios_SRCS})
endif(FREECAD_USE_EXTERNAL_ZIPIOS)


if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    ADD_MSVC_PRECOMPILED_HEADER(FreeCADBase PreCompiled.h PreCompiled.cpp FreeCADBase_CPP_SRCS)
endif(FREECAD_USE_PCH)

add_library(FreeCADBase SHARED ${FreeCADBase_SRCS})

target_link_libraries(FreeCADBase ${FreeCADBase_LIBS})

SET_BIN_DIR(FreeCADBase FreeCADBase)

if(WIN32)
    INSTALL(TARGETS FreeCADBase
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
else(WIN32)
    INSTALL(TARGETS FreeCADBase
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif(WIN32)

=== src/Build/CMakeLists.txt ===

set(PACKAGE_WCREF "$WCREV$")
set(PACKAGE_WCDATE "$WCDATE$")
set(PACKAGE_WCURL "$WCURL$")

# If the sources don't include a Version.h then create one
if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/Version.h)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Version.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/Version.h.in)

    add_custom_command(
        OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/Version.h
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/Version.h.out
            ${CMAKE_CURRENT_BINARY_DIR}/Version.h
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS version_check)

    add_custom_command(
        OUTPUT  version_check
        COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/src/Tools/SubWCRev.py
        --srcdir=${CMAKE_SOURCE_DIR} --bindir=${CMAKE_BINARY_DIR}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

    ADD_CUSTOM_TARGET(fc_version DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Version.h)

else (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/Version.h)

    ADD_CUSTOM_TARGET(fc_version DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Version.h)

endif (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/Version.h)

=== src/Main/CMakeLists.txt ===
#add_defintions(-D_FC_GUI_ENABLED_)
#add_defintions(-DFREECADMAINPY)

configure_file(freecad.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/freecad.rc)
configure_file(freecadCmd.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/freecadCmd.rc)
file(COPY icon.ico DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

if(BUILD_GUI)
    include_directories(
        ${Boost_INCLUDE_DIRS}
        ${COIN3D_INCLUDE_DIRS}
        ${ZLIB_INCLUDE_DIR}
        ${QT_INCLUDE_DIR}
        ${PYTHON_INCLUDE_DIRS}
        ${XercesC_INCLUDE_DIRS}
    )
else(BUILD_GUI)
    include_directories(
        ${Boost_INCLUDE_DIRS}
        ${ZLIB_INCLUDE_DIR}
        ${QT_INCLUDE_DIR}
        ${PYTHON_INCLUDE_DIRS}
        ${XercesC_INCLUDE_DIRS}
    )
endif(BUILD_GUI)

######################## FreeCADMain ########################
if(BUILD_GUI)

    SET(FreeCAD_SRCS
        ${CMAKE_CURRENT_BINARY_DIR}/freecad.rc
        icon.ico
        MainGui.cpp
    )

    SET(FreeCAD_LIBS
        FreeCADGui
    )

    if (MSVC AND NOT BUILD_QT5)
        list(APPEND FreeCAD_LIBS
            ${QT_QTMAIN_LIBRARY}
        )
    endif()

    if(NOT BUILD_DYNAMIC_LINK_PYTHON)
        # executables have to be linked against python libraries,
        # because extension modules are not.
        list(APPEND FreeCAD_LIBS
            ${PYTHON_LIBRARIES}
        )
    endif(NOT BUILD_DYNAMIC_LINK_PYTHON)

    add_executable(FreeCADMain WIN32 ${FreeCAD_SRCS})
    target_link_libraries(FreeCADMain ${FreeCAD_LIBS})

    SET_BIN_DIR(FreeCADMain FreeCAD)

    if(WIN32)
        INSTALL(TARGETS FreeCADMain
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
    elseif(APPLE AND NOT BUILD_WITH_CONDA)
        INSTALL(TARGETS FreeCADMain
	    RUNTIME DESTINATION MacOS
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
    else()
        INSTALL(TARGETS FreeCADMain
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        )
    endif()
endif(BUILD_GUI)
######################## FreeCADMainCmd ########################

SET(FreeCADMainCmd_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/freecadCmd.rc
    icon.ico
    MainCmd.cpp
)

add_executable(FreeCADMainCmd ${FreeCADMainCmd_SRCS})

SET(FreeCADMainCmd_LIBS
    FreeCADApp
)

if (BUILD_QT5)
    list(APPEND FreeCADMainCmd_LIBS
        ${Qt5Core_LIBRARIES}
        ${Qt5Xml_LIBRARIES}
    )
else()
    list(APPEND FreeCADMainCmd_LIBS
        ${QT_QTCORE_LIBRARY}
        ${QT_QTXML_LIBRARY}
    )
endif()

if(NOT BUILD_DYNAMIC_LINK_PYTHON)
    # executables have to be linked against python libraries,
    # because extension modules are not.
    list(APPEND FreeCADMainCmd_LIBS
        ${PYTHON_LIBRARIES}
    )
endif(NOT BUILD_DYNAMIC_LINK_PYTHON)

target_link_libraries(FreeCADMainCmd
    ${FreeCADMainCmd_LIBS}
)

SET_BIN_DIR(FreeCADMainCmd FreeCADCmd)

if(WIN32)
    INSTALL(TARGETS FreeCADMainCmd
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
elseif(APPLE AND NOT BUILD_WITH_CONDA)
    INSTALL(TARGETS FreeCADMainCmd
        RUNTIME DESTINATION MacOS
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
else()
    INSTALL(TARGETS FreeCADMainCmd
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

######################## FreeCADMainPy ########################

SET(FreeCADMainPy_SRCS
    MainPy.cpp
)

add_library(FreeCADMainPy SHARED ${FreeCADMainPy_SRCS})

target_link_libraries(FreeCADMainPy FreeCADApp)

SET_BIN_DIR(FreeCADMainPy FreeCAD)
SET_PYTHON_PREFIX_SUFFIX(FreeCADMainPy)

if(WIN32)
    INSTALL(TARGETS FreeCADMainPy
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
else(WIN32)
    INSTALL(TARGETS FreeCADMainPy
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif(WIN32)

######################## FreeCADGuiPy ########################
if(BUILD_GUI)

    SET(FreeCADGuiPy_SRCS
        FreeCADGuiPy.cpp
    )

    add_library(FreeCADGuiPy SHARED ${FreeCADGuiPy_SRCS})

    target_link_libraries(FreeCADGuiPy FreeCADGui)

    SET_BIN_DIR(FreeCADGuiPy FreeCADGui)
    SET_PYTHON_PREFIX_SUFFIX(FreeCADGuiPy)
    if(WIN32)
        # Name clash with target "FreeCADGui"
        # Must be called "FreeCADGuiPy_d" and "FreeCADGuiPy" to work so override default
        set_target_properties(FreeCADGuiPy PROPERTIES PDB_NAME_DEBUG "FreeCADGuiPy_d")
        set_target_properties(FreeCADGuiPy PROPERTIES PDB_NAME_RELEASE "FreeCADGuiPy")
    endif(WIN32)

    if(WIN32)
        INSTALL(TARGETS FreeCADGuiPy
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
    else(WIN32)
        INSTALL(TARGETS FreeCADGuiPy
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
    endif(WIN32)
endif(BUILD_GUI)

=== src/Mod/CMakeLists.txt ===

if(BUILD_POINTS)
  add_subdirectory(Points)
endif(BUILD_POINTS)

if(BUILD_COMPLETE)
  add_subdirectory(Complete)
endif(BUILD_COMPLETE)

if(BUILD_TEST)
  add_subdirectory(Test)
endif(BUILD_TEST)

#add_subdirectory(TemplatePyMod)

if(BUILD_IMAGE)
  add_subdirectory(Image)
endif(BUILD_IMAGE)

if(BUILD_MESH)
  add_subdirectory(Mesh)
endif(BUILD_MESH)

if(BUILD_PART)
  add_subdirectory(Part)
endif(BUILD_PART)

if(BUILD_MATERIAL)
  add_subdirectory(Material)
endif(BUILD_MATERIAL)

if(BUILD_PART_DESIGN)
  add_subdirectory(PartDesign)
endif(BUILD_PART_DESIGN)

if(BUILD_RAYTRACING)
  add_subdirectory(Raytracing)
endif(BUILD_RAYTRACING)

if(BUILD_DRAWING)
  add_subdirectory(Drawing)
endif(BUILD_DRAWING)

IF(EIGEN3_FOUND)
    if(BUILD_SKETCHER)
      add_subdirectory(Sketcher)
    endif(BUILD_SKETCHER)
    
    if(BUILD_ROBOT)
      add_subdirectory(Robot)
    endif(BUILD_ROBOT)
ELSE(EIGEN3_FOUND)
    MESSAGE("Due to the missing Eigen3 library the Sketcher module won't be built")
    MESSAGE("Due to the missing Eigen3 library the Robot module won't be built")
ENDIF(EIGEN3_FOUND)

if(BUILD_REVERSEENGINEERING)
  add_subdirectory(ReverseEngineering)
endif(BUILD_REVERSEENGINEERING)

if(BUILD_MESH_PART)
  add_subdirectory(MeshPart)
endif(BUILD_MESH_PART)

if(BUILD_DRAFT)
  add_subdirectory(Draft)
endif(BUILD_DRAFT)

if(BUILD_WEB)
  add_subdirectory(Web)
endif(BUILD_WEB)

if(BUILD_SURFACE)
  add_subdirectory(Surface)
endif(BUILD_SURFACE)

if(BUILD_START)
  add_subdirectory(Start)
endif(BUILD_START)

if(BUILD_IDF)
  add_subdirectory(Idf)
endif(BUILD_IDF)

if(BUILD_IMPORT)
  add_subdirectory(Import)
endif(BUILD_IMPORT)

if(BUILD_INSPECTION)
  add_subdirectory(Inspection)
endif(BUILD_INSPECTION)

if(BUILD_ARCH)
  add_subdirectory(Arch)
endif(BUILD_ARCH)

if(BUILD_ASSEMBLY)
  add_subdirectory(Assembly)
endif(BUILD_ASSEMBLY)

if(BUILD_FEM)
    add_subdirectory(Fem)
endif(BUILD_FEM)

if(BUILD_CLOUD)
    add_subdirectory(Cloud)
endif(BUILD_CLOUD)

if(BUILD_SANDBOX)
    add_subdirectory(Sandbox)
endif(BUILD_SANDBOX)

if(BUILD_SHIP)
  add_subdirectory(Ship)
endif(BUILD_SHIP)

if(BUILD_OPENSCAD)
  add_subdirectory(OpenSCAD)
endif(BUILD_OPENSCAD)

if(BUILD_PLOT)
  add_subdirectory(Plot)
endif(BUILD_PLOT)

if(BUILD_SPREADSHEET)
  add_subdirectory(Spreadsheet)
endif(BUILD_SPREADSHEET)

if(BUILD_JTREADER)
  add_subdirectory(JtReader)
endif(BUILD_JTREADER)

if(BUILD_PATH)
    add_subdirectory(Path)
endif(BUILD_PATH)

if(BUILD_SHOW)
    add_subdirectory(Show)
endif(BUILD_SHOW)

if(BUILD_TECHDRAW)
    add_subdirectory(Measure)
    add_subdirectory(TechDraw)
endif(BUILD_TECHDRAW)

if(BUILD_ADDONMGR)
  add_subdirectory(AddonManager)
endif(BUILD_ADDONMGR)

if(BUILD_TUX)
    add_subdirectory(Tux)
endif(BUILD_TUX)

=== src/3rdParty/lazy_loader/CMakeLists.txt ===
SET(lazy_loader
    lazy_loader.py
    __init__.py
)
add_custom_target(lazy_loader ALL SOURCES
    ${lazy_loader}
)
SET_PYTHON_PREFIX_SUFFIX(lazy_loader)

fc_copy_sources(lazy_loader "${CMAKE_BINARY_DIR}/Ext/lazy_loader" ${lazy_loader})
install (FILES ${lazy_loader} DESTINATION "${CMAKE_INSTALL_PREFIX}/Ext/lazy_loader")

=== src/3rdParty/salomesmesh/CMakeLists.txt ===
# SGEOM cmake build file
#PROJECT(SMESH Fortran CXX)

SET(SMESH_VERSION_MAJOR 7)  # see main CMakeLists.txt of FreeCAD
SET(SMESH_VERSION_MINOR 7)
SET(SMESH_VERSION_PATCH 1)
SET(SMESH_VERSION_TWEAK 0)

# Suppress gcc warnings
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -Wno-sign-compare -Wno-reorder -Wno-switch -Wno-unused-variable -Wno-unused-but-set-variable -Wno-comment -Wno-unused-parameter -Wno-empty-body -Wno-pedantic")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-but-set-variable")

    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-unused-result" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-result")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result")
    endif ()

    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-maybe-uninitialized" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-maybe-uninitialized")
    endif ()

    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-missing-field-initializers" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
    endif ()

# Suppress clang warnings
elseif(CMAKE_COMPILER_IS_CLANGXX)
    set(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -Wno-self-assign -Wno-sign-compare -Wno-logical-op-parentheses -Wno-reorder -Wno-switch -Wno-switch-enum -Wno-unknown-pragmas -Wno-unused-variable -Wno-unused-private-field")
    set(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -Wno-unused-function -Wno-sometimes-uninitialized -Wno-overloaded-virtual -Wno-dynamic-class-memaccess -Wno-comment -Wno-unused-parameter -Wno-extra-semi")

    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-deprecated-copy" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-copy")
    endif ()

    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-missing-field-initializers" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
    endif ()
endif()


if (VTK_OPTIONS)
    add_definitions(${VTK_OPTIONS})
endif()

include_directories(
    src/SMDS
    src/Driver
    src/DriverUNV
    src/DriverDAT
    src/DriverSTL
    src/StdMeshers
    inc
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${NGLIB_INCLUDE_DIR}
    ${NETGEN_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${VTK_INCLUDE_DIRS}
    ${HDF5_INCLUDE_DIR}
    ${MEDFILE_INCLUDE_DIRS}
    ${BOOST_INCLUDE_DIR}
)
link_directories(${OCC_LIBRARY_DIR})

if(MSVC)
    if(BUILD_FEM_NETGEN)
        set(SMESH_LIBS
            debug     MSVCRTD.LIB
            debug     MSVCPRTD.LIB
            optimized MSVCRT.LIB
            optimized MSVCPRT.LIB
            Rpcrt4.lib
            ${NGLIB_LIBRARIES}
            ${NGLIB_DEBUG_LIBRARIES}
            ${OCC_LIBRARIES}
            ${OCC_DEBUG_LIBRARIES}
            ${OCC_OCAF_DEBUG_LIBRARIES}
            ${OCC_OCAF_LIBRARIES}
        )
        ADD_DEFINITIONS(${NETGEN_DEFINITIONS})
    else(BUILD_FEM_NETGEN)
        set(SMESH_LIBS
            debug     MSVCRTD.LIB
            debug     MSVCPRTD.LIB
            optimized MSVCRT.LIB
            optimized MSVCPRT.LIB
            Rpcrt4.lib
            ${OCC_LIBRARIES}
            ${OCC_DEBUG_LIBRARIES}
            ${OCC_OCAF_DEBUG_LIBRARIES}
            ${OCC_OCAF_LIBRARIES}
        )
    endif(BUILD_FEM_NETGEN)

    #Universal C runtime introduced in VS 2015 (cl version 19)
    if (NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19"))
        list(APPEND SMESH_LIBS
            debug vcruntimed.lib
            debug ucrtd.lib
            optimized vcruntime.lib
            optimized ucrt.lib
        )
    endif()
else(MSVC)
    if(BUILD_FEM_NETGEN)
        set(SMESH_LIBS
            ${NGLIB_LIBRARIES}
            ${OCC_LIBRARIES}
            ${OCC_OCAF_LIBRARIES}
        )
        ADD_DEFINITIONS(${NETGEN_DEFINITIONS})
    else(BUILD_FEM_NETGEN)
        set(SMESH_LIBS
            ${OCC_LIBRARIES}
            ${OCC_OCAF_LIBRARIES}
        )
    endif(BUILD_FEM_NETGEN)
endif(MSVC)


#SET(CMAKE_BUILD_TYPE "Release") # By default, build in release mode
#SET(BUILD_SHARED_LIBS ON)
#SET(LIBRARY_OUTPUT_PATH cmake-build)
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
#INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
#INCLUDE_DIRECTORIES(inc)

#############
# FindBoost #
#############
#FIND_PACKAGE(Boost REQUIRED)
#MESSAGE("-- Boost found: ${Boost_FOUND}")
#INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
#MESSAGE("Popo: ${Boost_INCLUDE_DIR}")


########################################
# OpenCASCADE include and lib location #
########################################
# Find OpenCASCADE library, set include and lib path
#SET(OCC_INCLUDE_PATH ${OCC_INCLUDE_DIR})
#SET(OCC_LIB_PATH ${OCC_LIBRARY_DIR})

# Tells CMake where are the required headers
#INCLUDE_DIRECTORIES(${OCC_INCLUDE_PATH})
#LINK_DIRECTORIES(${OCC_LIB_PATH})


############################
# Check 32/64 bit platform #
############################
IF (${CMAKE_SIZEOF_VOID_P} MATCHES "8") # It is 64bit, 32 bit systems returns 4
    ADD_DEFINITIONS(-D_OCC64)
    IF(CMAKE_COMPILER_IS_GNUCXX)
    # 0001715: Mefisto Mesh Fails since translated by f2c
    #    ADD_DEFINITIONS(-DPCLINUX64)
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
    #MESSAGE("-- Build 64bit")
ELSE (${CMAKE_SIZEOF_VOID_P} MATCHES "8")
    #MESSAGE("-- Build 32bit")
ENDIF(${CMAKE_SIZEOF_VOID_P} MATCHES "8")

######################################################
# Configure Build settings according to the platform #
######################################################
IF(UNIX)
    # Same settings are used for both MacOSX and Unix/Linux
    ADD_DEFINITIONS(-DHAVE_CONFIG_H -DHAVE_LIMITS_H -DCSFDB -DLIN -DOCC_CONVERT_SIGNALS)
ELSE(UNIX)
  IF(WIN32)
    ######### Windows ###########
    #MESSAGE("-- Windows system detected")
    IF(MSVC)
        ADD_DEFINITIONS(-DWNT -DWIN32 -D_WINDOWS -DCSFDB -DUSE_CLOCK -DMSDOS -DNO_ONEXIT -DNO_My_ctype -DNO_ISATTY -DNO_FPINIT /wd4290 /wd4251 /wd4018 /wd4800 /wd4996 /wd4244 /wd4805 /wd4806 /wd4275 /wd4005 /wd4099 /wd4101 /wd4146 /wd4267 /wd4390 /wd4503 /wd4436)
    ELSE(MSVC)
        ADD_DEFINITIONS(-DWNT -DWIN32 -D_WINDOWS -DCSFDB)
    ENDIF(MSVC)
  ELSE(WIN32)
    MESSAGE("Unknown platform")
  ENDIF(WIN32)
ENDIF(UNIX)

#########
# SMDS #
#########
FILE(GLOB SMDS_source_files src/SMDS/*.cpp inc/SMDS*.hxx)
ADD_LIBRARY(SMDS SHARED ${SMDS_source_files})
TARGET_LINK_LIBRARIES(SMDS ${SMESH_LIBS} ${HDF5_C_STATIC_LIBRARY} ${VTK_LIBRARIES})

SET_BIN_DIR(SMDS SMDS)
if(WIN32)
    set_target_properties(SMDS PROPERTIES COMPILE_FLAGS "-DSMDS_EXPORTS -DUTILS_EXPORTS")
endif(WIN32)


##########
# Driver #
##########
FILE(GLOB Driver_source_files src/Driver/*.cpp inc/Driver_*.hxx)
ADD_LIBRARY(Driver SHARED ${Driver_source_files})
TARGET_LINK_LIBRARIES(Driver ${SMESH_LIBS})

SET_BIN_DIR(Driver Driver)
if(WIN32)
    set_target_properties(Driver PROPERTIES COMPILE_FLAGS "-DMESHDRIVER_EXPORTS -DSMESHUtils_EXPORTS")
endif(WIN32)


#IF(WIN32)
#  SET_TARGET_PROPERTIES(Driver PROPERTIES COMPILE_FLAGS "-DMESHDRIVER_EXPORTS")
#ENDIF(WIN32)
#IF(MINGW)
#  SET_TARGET_PROPERTIES(Driver PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)

#############
# DriverSTL #
#############
FILE(GLOB DriverSTL_source_files src/DriverSTL/*.cpp inc/DriverSTL*.h*)
ADD_LIBRARY(DriverSTL SHARED ${DriverSTL_source_files})
TARGET_LINK_LIBRARIES(DriverSTL ${SMESH_LIBS} Driver SMDS ${Boost_LIBRARIES})

SET_BIN_DIR(DriverSTL DriverSTL)
if(WIN32)
    set_target_properties(DriverSTL PROPERTIES COMPILE_FLAGS "-DMESHDRIVERSTL_EXPORTS -DBASICS_EXPORT -DSMESHUtils_EXPORTS -DBASICS_EXPORTS")
endif(WIN32)


#TARGET_LINK_LIBRARIES(DriverSTL TKernel TKMath Driver SMDS)
#IF(WIN32)
#  SET_TARGET_PROPERTIES(DriverSTL PROPERTIES COMPILE_FLAGS "-DMESHDRIVERSTL_EXPORTS")
#ENDIF(WIN32)
#IF(MINGW)
#  SET_TARGET_PROPERTIES(DriverSTL PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)

#############
# DriverDAT #
#############
FILE(GLOB DriverDAT_source_files src/DriverDAT/*.cpp inc/DriverDAT*.h*)
ADD_LIBRARY(DriverDAT SHARED ${DriverDAT_source_files})
TARGET_LINK_LIBRARIES(DriverDAT ${SMESH_LIBS} SMDS Driver)

SET_BIN_DIR(DriverDAT DriverDAT)
if(WIN32)
    set_target_properties(DriverDAT PROPERTIES COMPILE_FLAGS "-DMESHDRIVERDAT_EXPORTS")
endif(WIN32)


#IF(WIN32)
# SET_TARGET_PROPERTIES(DriverDAT PROPERTIES COMPILE_FLAGS "-DMESHDRIVERDAT_EXPORTS")
#ENDIF(WIN32)
#IF(MINGW)
#  SET_TARGET_PROPERTIES(DriverDAT PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)

#############
# DriverUNV #
#############
FILE(GLOB DriverUNV_source_files src/DriverUNV/*.cpp inc/DriverUNV*.h*)
ADD_LIBRARY(DriverUNV SHARED ${DriverUNV_source_files})
TARGET_LINK_LIBRARIES(DriverUNV ${SMESH_LIBS} SMESHDS SMDS Driver)

SET_BIN_DIR(DriverUNV DriverUNV)
if(WIN32)
    set_target_properties(DriverUNV PROPERTIES COMPILE_FLAGS "-DMESHDRIVERUNV_EXPORTS")
endif(WIN32)


#IF(WIN32)
#  SET_TARGET_PROPERTIES(DriverUNV PROPERTIES COMPILE_FLAGS "-DMESHDRIVERUNV_EXPORTS")
#ENDIF(WIN32)
#IF(MINGW)
#  SET_TARGET_PROPERTIES(DriverUNV PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)

###########
# SMESHDS #
###########
FILE(GLOB SMESHDS_source_files src/SMESHDS/*.cpp inc/SMESHDS_*.h*)
ADD_LIBRARY(SMESHDS SHARED ${SMESHDS_source_files})
TARGET_LINK_LIBRARIES(SMESHDS ${SMESH_LIBS} SMDS ${Boost_LIBRARIES} )

SET_BIN_DIR(SMESHDS SMESHDS)


#IF(MINGW)
#  SET_TARGET_PROPERTIES(SMESHDS PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)

#########
# SMESH #
#########
FILE(GLOB SMESH_source_files src/SMESH/*.c src/SMESH/*.cpp src/Controls/*.cpp inc/SMESH_*.h*)
ADD_LIBRARY(SMESH SHARED ${SMESH_source_files})
TARGET_LINK_LIBRARIES(SMESH SMDS SMESHDS  Driver DriverSTL DriverDAT DriverUNV ${SMESH_LIBS} ${OPENCASCADE_LIBRARIES} ${OCC_LIBRARIES} ${OCC_DEBUG_LIBRARIES} ${OCC_OCAF_DEBUG_LIBRARIES} ${OCC_OCAF_LIBRARIES} ${MEDFILE_LIBRARIES} ${VTK_LIBRARIES})
 
SET_BIN_DIR(SMESH SMESH)
if(WIN32)
    set_target_properties(SMESH PROPERTIES COMPILE_FLAGS "-DSMESH_EXPORTS -DSMESHCONTROLS_EXPORTS -DSMESHimpl_EXPORTS -DMESHDriverGMF_EXPORTS -DMESHDRIVERMED_EXPORTS -DMEDWRAPPER_EXPORTS -DMEDWRAPPER_BASE_EXPORTS -DMEDWRAPPER_FACTORY_EXPORTS -DSMESHUtils_EXPORTS -DUTILS_EXPORTS -DMEDWRAPPER_V2_2_EXPORTS")
endif(WIN32)
 

 #IF(WIN32)
#  SET_TARGET_PROPERTIES(SMESH PROPERTIES COMPILE_FLAGS "-DSMESHimpl_EXPORTS -DSMESHCONTROLS_EXPORTS")
#ENDIF(WIN32)
#IF(MINGW)
#  SET_TARGET_PROPERTIES(SMESH PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
#ENDIF(MINGW)


##############
# MEFISTO2   #
##############
#if (MSVC)
    #IF(CMAKE_SIZEOF_VOID_P EQUAL 8)
    #    # Mefisto2f.lib was built using f2c which created
    #    # all function names with an '_' at the end.
    #    FILE(GLOB MEFISTO2_source_files
    #        src/MEFISTO2/*.cpp
    #        inc/Rn.h
    #        inc/aptrte.h
    #    )
    #ELSE(CMAKE_SIZEOF_VOID_P EQUAL 8)
    #    FILE(GLOB MEFISTO2_source_files
    #        src/MEFISTO2/*.cpp
    #        src/MEFISTO2/MEFISTO2F.def
    #        inc/Rn.h
    #        inc/aptrte.h
    #    )
    #ENDIF(CMAKE_SIZEOF_VOID_P EQUAL 8)

        set(MEFISTO2_source_files
            src/MEFISTO2/aptrte.cpp
            src/MEFISTO2/trte.c
            inc/Rn.h
            inc/aptrte.h
        )        
    
#else(MSVC)
#    FILE(GLOB MEFISTO2_source_files
#        src/MEFISTO2/*.cpp
#        src/MEFISTO2/trte.f
#        inc/Rn.h
#        inc/aptrte.h
#    )
#endif(MSVC)

ADD_LIBRARY(MEFISTO2 SHARED ${MEFISTO2_source_files})

SET_BIN_DIR(MEFISTO2 MEFISTO2)
#if(MSVC)
    TARGET_LINK_LIBRARIES(MEFISTO2 ${SMESH_LIBS}) # in case of Windows link the prebuild Fortran lib
    set_target_properties(MEFISTO2 PROPERTIES COMPILE_FLAGS "-DMEFISTO2D_EXPORTS")

=== src/Mod/AddonManager/CMakeLists.txt ===
IF (BUILD_GUI)
    PYSIDE_WRAP_RC(AddonManager_QRC_SRCS Resources/AddonManager.qrc)
ENDIF (BUILD_GUI)

SET(AddonManager_SRCS
    Init.py
    InitGui.py
    AddonManager.py
    addonmanager_macro.py
    addonmanager_utilities.py
    addonmanager_workers.py
    AddonManager.ui
    AddonManagerOptions.ui
)

SOURCE_GROUP("" FILES ${AddonManager_SRCS})

ADD_CUSTOM_TARGET(AddonManager ALL
    SOURCES ${AddonManager_SRCS} ${AddonManager_QRC_SRCS}
)

fc_copy_sources(AddonManager "${CMAKE_BINARY_DIR}/Mod/AddonManager" ${AddonManager_SRCS})

IF (BUILD_GUI)
    fc_target_copy_resource(AddonManager
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/Mod/AddonManager
        AddonManager_rc.py)
ENDIF (BUILD_GUI)

INSTALL(
    FILES
        ${AddonManager_SRCS}
        ${AddonManager_QRC_SRCS}
    DESTINATION
        Mod/AddonManager
)

=== src/Mod/Assembly/CMakeLists.txt ===

option(FREECAD_ASSEMBLY_DEBUG_FACILITIES "Tune solver settings manual and generate extensive logs of the assembly solving process" OFF)

if(FREECAD_ASSEMBLY_DEBUG_FACILITIES)
  find_package(Boost COMPONENTS log REQUIRED)
  add_definitions(-DUSE_LOGGING)
  add_definitions(-DASSEMBLY_DEBUG_FACILITIES)
endif(FREECAD_ASSEMBLY_DEBUG_FACILITIES)

if(MSVC)
add_definitions(/wd4503)
add_definitions(/wd4181)
else(MSVC)
add_definitions(-DDCM_EXTERNAL_CORE)
add_definitions(-DDCM_EXTERNAL_3D)
add_definitions(-DDCM_EXTERNAL_STATE)
endif(MSVC)

add_subdirectory(App)
if(BUILD_GUI)
    add_subdirectory(Gui)
endif(BUILD_GUI)

INSTALL(
    FILES
        Init.py
        InitGui.py
    DESTINATION
        Mod/Assembly
)

=== src/Mod/Cloud/CMakeLists.txt ===
#----------------------------- Control certificate validation ------------
option(ALLOW_SELF_SIGNED_CERTIFICATE "Allow self signed certificate" OFF)
if (ALLOW_SELF_SIGNED_CERTIFICATE)
add_compile_options("-DALLOW_SELF_SIGNED_CERTIFICATE")
endif ()
#------------------------------ OpenSSL and CURL -------------------------
if (APPLE)
    find_package(PkgConfig REQUIRED)
    pkg_search_module(OPENSSL REQUIRED openssl)
    set (OPENSSL_LIBRARIES ${OPENSSL_LINK_LIBRARIES})
elseif(WIN32 AND LIBPACK_FOUND)
    SET( OPENSSL_INCLUDE_DIR ${FREECAD_LIBPACK_DIR}/include)
    SET( OPENSSL_LIBRARIES 
      optimized ${FREECAD_LIBPACK_DIR}/lib/openssl.lib debug ${FREECAD_LIBPACK_DIR}/lib/openssld.lib
      optimized ${FREECAD_LIBPACK_DIR}/lib/libssl.lib debug ${FREECAD_LIBPACK_DIR}/lib/libssld.lib
      optimized ${FREECAD_LIBPACK_DIR}/lib/libcrypto.lib debug ${FREECAD_LIBPACK_DIR}/lib/libcryptod.lib)
    if( EXISTS ${FREECAD_LIBPACK_DIR}/lib/openssl.lib)
       SET( OPENSSL_FOUND True)
     else()
        SET( OPENSSL_FOUND False)
        message( FATAL_ERROR "openssl not found!" )
    endif(EXISTS ${FREECAD_LIBPACK_DIR}/lib/openssl.lib)
    
    if(OPENSSL_INCLUDE_DIR AND EXISTS "${OPENSSL_INCLUDE_DIR}/openssl/opensslv.h")      
      file(STRINGS "${OPENSSL_INCLUDE_DIR}/openssl/opensslv.h" openssl_version_str
           REGEX "OPENSSL_VERSION_STR")
      string(REGEX MATCH "\".*"
        openssl_version_str ${openssl_version_str})
      string(REPLACE "\"" "" openssl_version_str ${openssl_version_str})
      set(OPENSSL_VERSION ${openssl_version_str})
  endif ()   
else()
    find_package(OpenSSL REQUIRED)
endif(APPLE)

if(OPENSSL_FOUND)
    message(STATUS "openssl-${OPENSSL_VERSION} has been found\n")
else()
    message( FATAL_ERROR "openssl not found!" )
endif(OPENSSL_FOUND)

IF(WIN32)
    SET( CURL_FOUND True)
    SET( CURL_INCLUDE_DIR ${FREECAD_LIBPACK_DIR}/include)
    SET( CURL_LIBRARIES
      optimized ${FREECAD_LIBPACK_DIR}/lib/libcurl.lib debug ${FREECAD_LIBPACK_DIR}/lib/libcurl_debug.lib)
    if( EXISTS ${FREECAD_LIBPACK_DIR}/lib/libcurl.lib)
       SET( CURL_FOUND True)
     else()
        SET( CURL_FOUND False)
        message( FATAL_ERROR "curl not found!" )
    endif(EXISTS ${FREECAD_LIBPACK_DIR}/lib/libcurl.lib)
ELSE()
    find_package(CURL REQUIRED)
ENDIF(WIN32)


if(CURL_FOUND)
    message(STATUS "CURL has been found\n")
endif(CURL_FOUND)
# ------------------------------------------------------------------------

add_subdirectory(App)
if(BUILD_GUI)
    add_subdirectory(Gui)
endif(BUILD_GUI)

set(Cloud_Scripts
    Init.py
)

if(BUILD_GUI)
    list (APPEND Cloud_Scripts InitGui.py)
endif(BUILD_GUI)

add_custom_target(CloudScripts ALL
    SOURCES ${Cloud_Scripts}
)

fc_target_copy_resource_flat(CloudScripts
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/Mod/Cloud
    ${Cloud_Scripts}
)

install(
    FILES
        ${Cloud_Scripts}
    DESTINATION
        Mod/Cloud
)

=== src/Mod/Draft/CMakeLists.txt ===
add_subdirectory(App)

IF (BUILD_GUI)
    PYSIDE_WRAP_RC(Draft_QRC_SRCS Resources/Draft.qrc)
ENDIF (BUILD_GUI)

SET(Draft_SRCS_base
    Init.py
    InitGui.py
    Draft.py
    DraftTools.py
    DraftGui.py
    DraftVecUtils.py
    DraftGeomUtils.py
    DraftLayer.py
    DraftFillet.py
    WorkingPlane.py
    TestDraft.py
    TestDraftGui.py
)

SET(Draft_import
    importAirfoilDAT.py
    importDXF.py
    importDWG.py
    importOCA.py
    importSVG.py
)

SET (Draft_geoutils
    draftgeoutils/__init__.py
    draftgeoutils/general.py
    draftgeoutils/edges.py
    draftgeoutils/intersections.py
    draftgeoutils/sort_edges.py
    draftgeoutils/faces.py
    draftgeoutils/geometry.py
    draftgeoutils/geo_arrays.py
    draftgeoutils/wires.py
    draftgeoutils/arcs.py
    draftgeoutils/fillets.py
    draftgeoutils/offsets.py
    draftgeoutils/linear_algebra.py
    draftgeoutils/cuboids.py
    draftgeoutils/circles.py
    draftgeoutils/circles_apollonius.py
    draftgeoutils/circle_inversion.py
    draftgeoutils/circles_incomplete.py
)

SET(Draft_tests
    drafttests/__init__.py
    drafttests/auxiliary.py
    drafttests/test_import.py
    drafttests/test_import_gui.py
    drafttests/test_import_tools.py
    drafttests/test_pivy.py
    drafttests/test_creation.py
    drafttests/test_modification.py
    drafttests/test_svg.py
    drafttests/test_dxf.py
    drafttests/test_dwg.py
    drafttests/test_oca.py
    drafttests/test_airfoildat.py
    drafttests/draft_test_objects.py
    drafttests/README.md
)

SET(Draft_utilities
    draftutils/__init__.py
    draftutils/groups.py
    draftutils/init_tools.py
    draftutils/init_draft_statusbar.py
    draftutils/units.py
    draftutils/utils.py
    draftutils/gui_utils.py
    draftutils/todo.py
    draftutils/translate.py
    draftutils/messages.py
    draftutils/README.md
)

SET(Draft_functions
    draftfunctions/__init__.py
    draftfunctions/array.py
    draftfunctions/cut.py
    draftfunctions/downgrade.py
    draftfunctions/draftify.py
    draftfunctions/dxf.py
    draftfunctions/extrude.py
    draftfunctions/fuse.py
    draftfunctions/heal.py
    draftfunctions/join.py
    draftfunctions/mirror.py
    draftfunctions/move.py
    draftfunctions/offset.py
    draftfunctions/rotate.py
    draftfunctions/scale.py
    draftfunctions/split.py
    draftfunctions/svg.py
    draftfunctions/svgshapes.py
    draftfunctions/svgtext.py
    draftfunctions/upgrade.py
    draftfunctions/README.md
)

SET(Draft_make_functions
    draftmake/__init__.py
    draftmake/make_arc_3points.py
    draftmake/make_array.py
    draftmake/make_bezcurve.py
    draftmake/make_block.py
    draftmake/make_bspline.py
    draftmake/make_circle.py
    draftmake/make_circulararray.py
    draftmake/make_clone.py
    draftmake/make_copy.py
    draftmake/make_dimension.py
    draftmake/make_drawingview.py
    draftmake/make_ellipse.py
    draftmake/make_facebinder.py
    draftmake/make_fillet.py
    draftmake/make_label.py
    draftmake/make_layer.py
    draftmake/make_line.py
    draftmake/make_orthoarray.py
    draftmake/make_patharray.py
    draftmake/make_point.py
    draftmake/make_pointarray.py
    draftmake/make_polararray.py
    draftmake/make_polygon.py
    draftmake/make_rectangle.py
    draftmake/make_shape2dview.py
    draftmake/make_shapestring.py
    draftmake/make_sketch.py
    draftmake/make_text.py
    draftmake/make_wire.py
    draftmake/make_wpproxy.py
    draftmake/README.md
)

SET(Draft_objects
    draftobjects/__init__.py
    draftobjects/array.py
    draftobjects/base.py
    draftobjects/bezcurve.py
    draftobjects/block.py
    draftobjects/bspline.py
    draftobjects/circle.py
    draftobjects/clone.py
    draftobjects/drawingview.py
    draftobjects/ellipse.py
    draftobjects/facebinder.py
    draftobjects/draft_annotation.py
    draftobjects/fillet.py
    draftobjects/draftlink.py
    draftobjects/label.py
    draftobjects/layer.py
    draftobjects/dimension.py
    draftobjects/patharray.py
    draftobjects/pathtwistedarray.py
    draftobjects/point.py
    draftobjects/pointarray.py
    draftobjects/polygon.py
    draftobjects/rectangle.py
    draftobjects/shapestring.py
    draftobjects/shape2dview.py
    draftobjects/text.py
    draftobjects/wire.py
    draftobjects/wpproxy.py
    draftobjects/README.md
)

SET(Draft_view_providers
    draftviewproviders/__init__.py
    draftviewproviders/view_array.py
    draftviewproviders/view_base.py
    draftviewproviders/view_bezcurve.py
    draftviewproviders/view_bspline.py
    draftviewproviders/view_circulararray.py
    draftviewproviders/view_clone.py
    draftviewproviders/view_facebinder.py
    draftviewproviders/view_orthoarray.py
    draftviewproviders/view_polararray.py
    draftviewproviders/view_draft_annotation.py
    draftviewproviders/view_fillet.py
    draftviewproviders/view_draftlink.py
    draftviewproviders/view_label.py
    draftviewproviders/view_layer.py
    draftviewproviders/view_dimension.py
    draftviewproviders/view_point.py
    draftviewproviders/view_rectangle.py
    draftviewproviders/view_text.py
    draftviewproviders/view_wire.py
    draftviewproviders/view_wpproxy.py
    draftviewproviders/README.md
)

SET(Creator_tools
    draftguitools/gui_lines.py
    draftguitools/gui_fillets.py
    draftguitools/gui_splines.py
    draftguitools/gui_beziers.py
    draftguitools/gui_rectangles.py
    draftguitools/gui_arcs.py
    draftguitools/gui_circles.py
    draftguitools/gui_polygons.py
    draftguitools/gui_ellipses.py
    draftguitools/gui_texts.py
    draftguitools/gui_dimensions.py
    draftguitools/gui_shapestrings.py
    draftguitools/gui_points.py
    draftguitools/gui_facebinders.py
    draftguitools/gui_labels.py
)

SET(Modifier_tools
    draftguitools/gui_subelements.py
    draftguitools/gui_move.py
    draftguitools/gui_styles.py
    draftguitools/gui_rotate.py
    draftguitools/gui_offset.py
    draftguitools/gui_stretch.py
    draftguitools/gui_join.py
    draftguitools/gui_split.py
    draftguitools/gui_upgrade.py
    draftguitools/gui_downgrade.py
    draftguitools/gui_trimex.py
    draftguitools/gui_scale.py
    draftguitools/gui_drawing.py
    draftguitools/gui_wire2spline.py
    draftguitools/gui_shape2dview.py
    draftguitools/gui_draft2sketch.py
    draftguitools/gui_arrays.py
    draftguitools/gui_array_simple.py
    draftguitools/gui_circulararray.py
    draftguitools/gui_orthoarray.py
    draftguitools/gui_patharray.py
    draftguitools/gui_pathtwistedarray.py
    draftguitools/gui_pointarray.py
    draftguitools/gui_polararray.py
    draftguitools/gui_clone.py
    draftguitools/gui_mirror.py
)

SET(Draft_GUI_tools
    draftguitools/__init__.py
    draftguitools/gui_annotationstyleeditor.py
    draftguitools/gui_base.py
    draftguitools/gui_base_original.py
    draftguitools/gui_tool_utils.py
    draftguitools/gui_planeproxy.py
    draftguitools/gui_selectplane.py
    draftguitools/gui_snaps.py
    draftguitools/gui_snapper.py
    draftguitools/gui_trackers.py
    draftguitools/gui_edit_base_object.py
    draftguitools/gui_edit_draft_objects.py
    draftguitools/gui_edit_arch_objects.py
    draftguitools/gui_edit_part_objects.py
    draftguitools/gui_edit_sketcher_objects.py
    draftguitools/gui_edit.py
    draftguitools/gui_lineops.py
    draftguitools/gui_togglemodes.py
    draftguitools/gui_groups.py
    draftguitools/gui_grid.py
    draftguitools/gui_heal.py
    draftguitools/gui_dimension_ops.py
    draftguitools/gui_lineslope.py
    draftguitools/gui_layers.py
    draftguitools/gui_setstyle.py
    ${Creator_tools}
    ${Modifier_tools}
    draftguitools/README.md
)

SET(Draft_task_panels
    drafttaskpanels/__init__.py
    drafttaskpanels/task_circulararray.py
    drafttaskpanels/task_orthoarray.py
    drafttaskpanels/task_polararray.py
    drafttaskpanels/task_scale.py
    drafttaskpanels/task_selectplane.py
    drafttaskpanels/task_shapestring.py
    drafttaskpanels/README.md
)

SET(Draft_SRCS_all
    ${Draft_SRCS_base}
    ${Draft_import}
    ${Draft_geoutils}
    ${Draft_tests}
    ${Draft_utilities}
    ${Draft_functions}
    ${Draft_make_functions}
    ${Draft_objects}
    ${Draft_view_providers}
    ${Draft_GUI_tools}
    ${Draft_task_panels}
)

# Cmake documentation: source_group defines a group into which sources
# will be placed in project files. This is intended to set up file tabs
# in Visual Studio.
#
# Maybe we don't need this anymore? For example, FEM doesn't use it.
SOURCE_GROUP("" FILES ${Draft_SRCS_all})

SET(DraftGuiIcon_SVG
    Resources/icons/DraftWorkbench.svg
)

ADD_CUSTOM_TARGET(Draft ALL
    SOURCES ${Draft_SRCS_all} ${Draft_QRC_SRCS} ${DraftGuiIcon_SVG}
)

fc_copy_sources(Draft "${CMAKE_BINARY_DIR}/Mod/Draft" ${Draft_SRCS_all})

fc_copy_sources(Draft "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Draft" ${DraftGuiIcon_SVG})

IF (BUILD_GUI)
    fc_target_copy_resource(Draft
        "${CMAKE_CURRENT_BINARY_DIR}"
        "${CMAKE_BINARY_DIR}/Mod/Draft"
        Draft_rc.py)
ENDIF (BUILD_GUI)

INSTALL(
    FILES
        ${Draft_SRCS_base}
        ${Draft_import}
        ${Draft_QRC_SRCS}
    DESTINATION
        Mod/Draft
)

INSTALL(FILES ${Draft_tests} DESTINATION Mod/Draft/drafttests)
INSTALL(FILES ${Draft_geoutils} DESTINATION Mod/Draft/draftgeoutils)
INSTALL(FILES ${Draft_utilities} DESTINATION Mod/Draft/draftutils)
INSTALL(FILES ${Draft_functions} DESTINATION Mod/Draft/draftfunctions)
INSTALL(FILES ${Draft_make_functions} DESTINATION Mod/Draft/draftmake)
INSTALL(FILES ${Draft_objects} DESTINATION Mod/Draft/draftobjects)
INSTALL(FILES ${Draft_view_providers} DESTINATION Mod/Draft/draftviewproviders)
INSTALL(FILES ${Draft_GUI_tools} DESTINATION Mod/Draft/draftguitools)
INSTALL(FILES ${Draft_task_panels} DESTINATION Mod/Draft/drafttaskpanels)

INSTALL(
    FILES
        ${DraftGuiIcon_SVG}
    DESTINATION
       "${CMAKE_INSTALL_DATADIR}/Mod/Draft/Resources/icons"
)

=== src/Mod/Fem/CMakeLists.txt ===

if(BUILD_FEM_VTK)
    add_definitions(-DFC_USE_VTK)
endif(BUILD_FEM_VTK)


# suppress warnings from smesh
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-overloaded-virtual")
endif()


# ************************************************************************************************
# ****** sub directories**************************************************************************
# ************************************************************************************************

add_subdirectory(App)

if(BUILD_GUI)
    add_subdirectory(Gui)
endif(BUILD_GUI)



# ************************************************************************************************
# ****** Python non Gui packages and modules *****************************************************
# ************************************************************************************************

SET(FemBaseModules_SRCS
    coding_conventions.md
    Init.py
    InitGui.py
    ObjectsFem.py
    TestFemApp.py
)

SET(FemCommands_SRCS
    femcommands/__init__.py
    femcommands/commands.py
    femcommands/manager.py
)

SET(FemExamples_SRCS
    femexamples/__init__.py
    femexamples/boxanalysis_static.py
    femexamples/boxanalysis_frequency.py
    femexamples/ccx_cantilever_faceload.py
    femexamples/ccx_cantilever_nodeload.py
    femexamples/ccx_cantilever_hexa20faceload.py
    femexamples/ccx_cantilever_prescribeddisplacement.py
    femexamples/constraint_contact_shell_shell.py
    femexamples/constraint_contact_solid_solid.py
    femexamples/constraint_section_print.py
    femexamples/constraint_selfweight_cantilever.py
    femexamples/constraint_tie.py
    femexamples/constraint_transform_beam_hinged.py
    femexamples/examplesgui.py
    femexamples/equation_electrostatics_capacitance_two_balls.py
    femexamples/equation_electrostatics_electricforce_elmer_nongui6.py
    femexamples/manager.py
    femexamples/material_multiple_bendingbeam_fiveboxes.py
    femexamples/material_multiple_bendingbeam_fivefaces.py
    femexamples/material_multiple_tensionrod_twoboxes.py
    femexamples/material_nl_platewithhole.py
    femexamples/rc_wall_2d.py
    femexamples/square_pipe_end_twisted_edgeforces.py
    femexamples/square_pipe_end_twisted_nodeforces.py
    femexamples/thermomech_bimetall.py
    femexamples/thermomech_flow1d.py
    femexamples/thermomech_spine.py
)

SET(FemExampleMeshes_SRCS
    femexamples/meshes/__init__.py
    femexamples/meshes/mesh_boxanalysis_tetra10.py
    femexamples/meshes/mesh_boxes_2_vertikal_tetra10.py
    femexamples/meshes/mesh_canticcx_hexa20.py
    femexamples/meshes/mesh_canticcx_tetra10.py
    femexamples/meshes/mesh_capacitance_two_balls_tetra10.py
    femexamples/meshes/mesh_constraint_tie_tetra10.py
    femexamples/meshes/mesh_contact_box_halfcylinder_tetra10.py
    femexamples/meshes/mesh_contact_tube_tube_tria3.py
    femexamples/meshes/mesh_electricforce_elmer_nongui6_tetra10.py
    femexamples/meshes/mesh_multibodybeam_tetra10.py
    femexamples/meshes/mesh_multibodybeam_tria6.py
    femexamples/meshes/mesh_platewithhole_tetra10.py
    femexamples/meshes/mesh_rc_wall_2d_tria6.py
    femexamples/meshes/mesh_section_print_tetra10.py
    femexamples/meshes/mesh_selfweight_cantilever_tetra10.py
    femexamples/meshes/mesh_square_pipe_end_twisted_tria6.py
    femexamples/meshes/mesh_thermomech_bimetall_tetra10.py
    femexamples/meshes/mesh_thermomech_flow1d_seg3.py
    femexamples/meshes/mesh_thermomech_spine_tetra10.py
    femexamples/meshes/mesh_transform_beam_hinged_tetra10.py
)

SET(FemInOut_SRCS
    feminout/__init__.py
    feminout/convert2TetGen.py
    feminout/importCcxDatResults.py
    feminout/importCcxFrdResults.py
    feminout/importFenicsMesh.py
    feminout/importInpMesh.py
    feminout/importPyMesh.py
    feminout/importToolsFem.py
    feminout/importVTKResults.py
    feminout/importYamlJsonMesh.py
    feminout/importZ88Mesh.py
    feminout/importZ88O2Results.py
    feminout/readFenicsXDMF.py
    feminout/readFenicsXML.py
    feminout/writeFenicsXDMF.py
    feminout/writeFenicsXML.py
)

SET(FemMesh_SRCS
    femmesh/__init__.py
    femmesh/femmesh2mesh.py
    femmesh/gmshtools.py
    femmesh/meshtools.py
)

SET(FemObjects_SRCS
    femobjects/__init__.py
    femobjects/base_fempythonobject.py
    femobjects/constant_vacuumpermittivity.py
    femobjects/constraint_bodyheatsource.py
    femobjects/constraint_electrostaticpotential.py
    femobjects/constraint_flowvelocity.py
    femobjects/constraint_initialflowvelocity.py
    femobjects/constraint_sectionprint.py
    femobjects/constraint_selfweight.py
    femobjects/constraint_tie.py
    femobjects/element_fluid1D.py
    femobjects/element_geometry1D.py
    femobjects/element_geometry2D.py
    femobjects/element_rotation1D.py
    femobjects/material_common.py
    femobjects/material_mechanicalnonlinear.py
    femobjects/material_reinforced.py
    femobjects/mesh_boundarylayer.py
    femobjects/mesh_gmsh.py
    femobjects/mesh_group.py
    femobjects/mesh_region.py
    femobjects/mesh_result.py
    femobjects/result_mechanical.py
    femobjects/solver_ccxtools.py
)

SET(FemResult_SRCS
    femresult/__init__.py
    femresult/resulttools.py
)

SET(FemSolver_SRCS
    femsolver/__init__.py
    femsolver/equationbase.py
    femsolver/report.py
    femsolver/reportdialog.py
    femsolver/run.py
    femsolver/settings.py
    femsolver/signal.py
    femsolver/solver_taskpanel.py
    femsolver/solverbase.py
    femsolver/task.py
    femsolver/writerbase.py
)

SET(FemSolverCalculix_SRCS
    femsolver/calculix/__init__.py
    femsolver/calculix/solver.py
    femsolver/calculix/tasks.py
    femsolver/calculix/writer.py
)

SET(FemSolverElmer_SRCS
    femsolver/elmer/__init__.py
    femsolver/elmer/sifio.py
    femsolver/elmer/solver.py
    femsolver/elmer/tasks.py
    femsolver/elmer/writer.py
)

SET(FemSolverElmerEquations_SRCS
    femsolver/elmer/equations/__init__.py
    femsolver/elmer/equations/electricforce.py
    femsolver/elmer/equations/electrostatic.py
    femsolver/elmer/equations/elasticity.py
    femsolver/elmer/equations/equation.py
    femsolver/elmer/equations/flow.py
    femsolver/elmer/equations/flux.py
    femsolver/elmer/equations/heat.py
    femsolver/elmer/equations/linear.py
    femsolver/elmer/equations/nonlinear.py
)

SET(FemSolverFenics_SRCS
    femsolver/fenics/__init__.py
    femsolver/fenics/fenics_tools.py
)

SET(FemSolverZ88_SRCS
    femsolver/z88/__init__.py
    femsolver/z88/solver.py
    femsolver/z88/tasks.py
    femsolver/z88/writer.py
)

SET(FemTests_SRCS
    femtest/__init__.py
    femtest/test_commands.sh
    femtest/test_information.md
)

SET(FemTestsApp_SRCS
    femtest/app/__init__.py
    femtest/app/support_utils.py
    femtest/app/test_ccxtools.py
    femtest/app/test_common.py
    femtest/app/test_femimport.py
    femtest/app/test_material.py
    femtest/app/test_mesh.py
    femtest/app/test_object.py
    femtest/app/test_open.py
    femtest/app/test_result.py
    femtest/app/test_solver_calculix.py
    femtest/app/test_solver_elmer.py
    femtest/app/test_solver_z88.py
)

SET(FemTestsFiles_SRCS
    femtest/data/__init__.py
)

SET(FemTestsCcx_SRCS
    femtest/data/calculix/__init__.py
    femtest/data/calculix/box_frequency.inp
    femtest/data/calculix/box_frequency.dat
    femtest/data/calculix/box_frequency.frd
    femtest/data/calculix/box_frequency_expected_values
    femtest/data/calculix/box_frequency.FCStd
    femtest/data/calculix/box_static.inp
    femtest/data/calculix/box_static.dat
    femtest/data/calculix/box_static.frd
    femtest/data/calculix/box_static_expected_values
    femtest/data/calculix/box_static.FCStd
    femtest/data/calculix/box.FCStd
    femtest/data/calculix/ccxcantilever_faceload.inp
    femtest/data/calculix/ccxcantilever_hexa20.inp
    femtest/data/calculix/ccxcantilever_nodeload.inp
    femtest/data/calculix/ccxcantilever_prescribeddisplacement.inp
    femtest/data/calculix/constraint_contact_shell_shell.FCStd
    femtest/data/calculix/constraint_contact_shell_shell.inp
    femtest/data/calculix/constraint_contact_solid_solid.FCStd
    femtest/data/calculix/constraint_contact_solid_solid.inp
    femtest/data/calculix/constraint_sectionprint.inp
    femtest/data/calculix/constraint_selfweight_cantilever.inp
    femtest/data/calculix/constraint_tie.inp
    femtest/data/calculix/material_multiple_bendingbeam_fiveboxes.inp
    femtest/data/calculix/material_multiple_bendingbeam_fivefaces.inp
    femtest/data/calculix/material_multiple_tensionrod_twoboxes.inp
    femtest/data/calculix/material_nonlinear.inp
    femtest/data/calculix/square_pipe_end_twisted_edgeforces.inp
    femtest/data/calculix/square_pipe_end_twisted_nodeforces.inp
    femtest/data/calculix/thermomech_bimetall.inp
    femtest/data/calculix/thermomech_flow1D.inp
    femtest/data/calculix/thermomech_flow1D.dat
    femtest/data/calculix/thermomech_flow1D.frd
    femtest/data/calculix/thermomech_flow1D_expected_values
    femtest/data/calculix/thermomech_flow1D_inout_nodes.txt
    femtest/data/calculix/thermomech_flow1D.FCStd
    femtest/data/calculix/thermomech_spine.inp
    femtest/data/calculix/thermomech_spine.dat
    femtest/data/calculix/thermomech_spine.frd
    femtest/data/calculix/thermomech_spine_expected_values
    femtest/data/calculix/thermomech_spine.FCStd
)

SET(FemTestsElmer_SRCS
    femtest/data/elmer/__init__.py
    femtest/data/elmer/box_static_0_mm.sif
    femtest/data/elmer/ccxcantilever_faceload_0_mm.sif
    femtest/data/elmer/ccxcantilever_faceload_1_si.sif
    femtest/data/elmer/ccxcantilever_nodeload_0_mm.sif
    femtest/data/elmer/ccxcantilever_prescribeddisplacement_0_mm.sif
    femtest/data/elmer/group_mesh.geo
    femtest/data/elmer/ELMERSOLVER_STARTINFO
)

SET(FemTestsMesh_SRCS
    femtest/data/mesh/__init__.py
    femtest/data/mesh/tetra10_mesh.inp
    femtest/data/mesh/tetra10_mesh.unv
    femtest/data/mesh/tetra10_mesh.vtk
    femtest/data/mesh/tetra10_mesh.yml
    femtest/data/mesh/tetra10_mesh.z88
)

SET(FemTestsOpen_SRCS
    femtest/data/open/__init__.py
    femtest/data/open/all_objects_de9b3fb438.FCStd
)

SET(FemTestsZ88Main_SRCS
    femtest/data/z88/__init__.py
)

SET(FemTestsZ88Ccxcantifl_SRCS
    femtest/data/z88/__init__.py
    femtest/data/z88/ccxcantilever_faceload/51.txt
    femtest/data/z88/ccxcantilever_faceload/z88.dyn
    femtest/data/z88/ccxcantilever_faceload/z88elp.txt
    femtest/data/z88/ccxcantilever_faceload/z88i1.txt
    femtest/data/z88/ccxcantilever_faceload/z88i2.txt
    femtest/data/z88/ccxcantilever_faceload/z88i5.txt
    femtest/data/z88/ccxcantilever_faceload/z88int.txt
    femtest/data/z88/ccxcantilever_faceload/z88man.txt
    femtest/data/z88/ccxcantilever_faceload/z88mat.txt
)

SET(FemTestsZ88Ccxcantihex_SRCS
    femtest/data/z88/__init__.py
    femtest/data/z88/ccxcantilever_hexa20/51.txt
    femtest/data/z88/ccxcantilever_hexa20/z88.dyn
    femtest/data/z88/ccxcantilever_hexa20/z88elp.txt
    femtest/data/z88/ccxcantilever_hexa20/z88i1.txt
    femtest/data/z88/ccxcantilever_hexa20/z88i2.txt
    femtest/data/z88/ccxcantilever_hexa20/z88i5.txt
    femtest/data/z88/ccxcantilever_hexa20/z88int.txt
    femtest/data/z88/ccxcantilever_hexa20/z88man.txt
    femtest/data/z88/ccxcantilever_hexa20/z88mat.txt
)

SET(FemTestsZ88Ccxcantinl_SRCS
    femtest/data/z88/__init__.py
    femtest/data/z88/ccxcantilever_nodeload/51.txt
    femtest/data/z88/ccxcantilever_nodeload/z88.dyn
    femtest/data/z88/ccxcantilever_nodeload/z88elp.txt
    femtest/data/z88/ccxcantilever_nodeload/z88i1.txt
    femtest/data/z88/ccxcantilever_nodeload/z88i2.txt
    femtest/data/z88/ccxcantilever_nodeload/z88i5.txt
    femtest/data/z88/ccxcantilever_nodeload/z88int.txt
    femtest/data/z88/ccxcantilever_nodeload/z88man.txt
    femtest/data/z88/ccxcantilever_nodeload/z88mat.txt
)

SET(FemTools_SRCS
    femtools/__init__.py
    femtools/ccxtools.py
    femtools/checksanalysis.py
    femtools/constants.py

=== debian/changelog ===
freecad (0.19.1+dfsg1-2+deb11u1) bullseye-security; urgency=medium

  * Non-maintainer upload by the Security Team.
  * CVE-2021-45844 and CVE-2021-45845: 
    - Fix two external command execution issues in Python scripts that are
      vunlnerbale to OS command injection when crafted input file is applied

 -- Aron Xu <aron@debian.org>  Thu, 18 Aug 2022 15:02:04 +0800

freecad (0.19.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * [aed47c1] Fix whitespaces in previous commit from Christian Ehrhardt,
    breaking python autopkgtests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Mar 2021 17:55:02 +0100

freecad (0.19.1+dfsg1-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * [fbc90b2] skip self test open_de9b3fb438 on s390x as it goes OOM
    (LP: #1918474)(Closes: #984952)

  [ Kurt Kremitzki ]
  * [3ae55a4] New upstream version 0.19.1+dfsg1
  * [bc2242e] Drop fix-fem-crash.patch, included in 0.19.1

 -- Kurt Kremitzki <kkremitzki@debian.org>  Mon, 15 Mar 2021 21:00:32 -0500

freecad (0.19+dfsg1-2) unstable; urgency=medium

  * [e19be27] Add patch to fix crash in FEM Constraint::getDirection
    (Closes: #983590)

 -- Kurt Kremitzki <kkremitzki@debian.org>  Sun, 28 Feb 2021 03:36:37 -0600

freecad (0.19+dfsg1-1) unstable; urgency=medium

  * [40577ea] New upstream version 0.19+dfsg1
  * [f346346] Add python3-matplotlib build dependency

 -- Kurt Kremitzki <kkremitzki@debian.org>  Thu, 25 Feb 2021 11:53:32 -0600

freecad (0.19~pre1+git20210207.a3fb41502b+dfsg-1) unstable; urgency=medium

  * [fc00a73] New upstream version 0.19~pre1+git20210207.a3fb41502b+dfsg
  * [b1f38b0] Refresh patches

 -- Kurt Kremitzki <kkremitzki@debian.org>  Sun, 07 Feb 2021 18:46:40 -0600

freecad (0.19~pre1+git20210109.afd1470202+dfsg1-2) unstable; urgency=medium

  * [bcad731] Add python3-yaml runtime dep
  * [4f5dd12] Set FREECAD_USER_HOME for autopkgtest

 -- Kurt Kremitzki <kkremitzki@debian.org>  Wed, 20 Jan 2021 10:49:37 -0600

freecad (0.19~pre1+git20210109.afd1470202+dfsg1-1) unstable; urgency=medium

  * [1395c4c] Update freecad-common symlinks (Closes: #980292)
  * [154c84e] New upstream version 0.19~pre1+git20210109.afd1470202+dfsg1

 -- Kurt Kremitzki <kkremitzki@debian.org>  Mon, 18 Jan 2021 12:48:25 -0600

freecad (0.19~pre1+git20201221.3b449e1ce9+dfsg1-2) unstable; urgency=medium

  * [2ce772e] Add Breaks+Replaces for libfreecad-python3-0.19 over 0.18
    (Closes: #976430)
  * [0046d46] Always only --list-missing

 -- Kurt Kremitzki <kkremitzki@debian.org>  Thu, 24 Dec 2020 06:54:50 -0600

freecad (0.19~pre1+git20201221.3b449e1ce9+dfsg1-1) unstable; urgency=medium

  * [921e9bc] New upstream version 0.19~pre1+git20201221.3b449e1ce9+dfsg1
  * [ea5594a] Refresh python3.8.patch

 -- Kurt Kremitzki <kkremitzki@debian.org>  Mon, 21 Dec 2020 11:23:53 -0600

freecad (0.19~pre1+git20201123.8d73c8f0+dfsg1-1) experimental; urgency=medium

  * [ede52e5] New upstream version 0.19~pre1+git20201123.8d73c8f0+dfsg1
  * [b8be794] Refresh patches
  * [5b061b9] Update packaging for 0.19

 -- Kurt Kremitzki <kkremitzki@debian.org>  Sun, 29 Nov 2020 03:20:11 -0600

freecad (0.18.4+dfsg2-6) unstable; urgency=medium

  * Team upload.
  * [63b9bcf] Fix compilation against boost and python3.9.
              (Closes: #975267, #973285)
  * [5773c7e] Use secure URI in Homepage field.
  * [ffb3bbb] Set debhelper-compat version in Build-Depends.
  * [15de038] Set upstream metadata fields: Repository, Repository-Browse.
  * [afe02a4] Fix day-of-week for changelog entry 0.7.1031-1.
  * [159b458] Update standards version to 4.5.0, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Thu, 19 Nov 2020 20:50:53 +0100

freecad (0.18.4+dfsg2-5) unstable; urgency=medium

  * [6ef07803] cherry-pick upstream commits:
    - 17ed2b196a58afbbc3cc1bb99f6eb76060171ad2
    - 1666b28836baa79b26b707afb1e97c2a0855eb1f
    - 1bca53917db942aa8e0639c8e2c2f33b2e09c1b0
    and drop new-pyside2.patch patch
  * [ 1b8737ca ]Drop depends on python3-pyside2uic,
    dropped by pyside2 (experimental), and add
    pyqt5-dev-tools for new pyrcc5 tool

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 07 Jun 2020 14:39:33 +0200

freecad (0.18.4+dfsg2-4) unstable; urgency=medium

  * Team upload

  [ Gianfranco Costamagna ]
  * [224b2c8a] Drop unused libboost-signals-dev (Closes: #962086)

  [ Graham Inggs ]
  * [e3aa33cd] Fix TaperedHole test for OCCT 7.4 (Closes: #961131)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 06 Jun 2020 12:07:18 +0200

freecad (0.18.4+dfsg2-3) unstable; urgency=medium

  * [a1d5760] Disable netgen builds for now
  * [cbbde84] Add patch for OCCT 7.4 regression test case

 -- Kurt Kremitzki <kurt@kwk.systems>  Wed, 20 May 2020 03:48:36 -0500

freecad (0.18.4+dfsg2-2) unstable; urgency=medium

  [ Tobias Frost ]
  * [b742def] Import Ubuntu patches to fix Python 3.8 FTBFS (Closes: #953721).
    This also includes some other patches from Ubuntu that are worth as they
    are fixing crashes. Thanks to Gianfranco for his work in Ubuntu.

  [ Kurt Kremitzki ]
  * [d56ac71] Correct line ending issue with patch
  * [599ea99] Add opencascade74.patch (Closes: #956543)

 -- Kurt Kremitzki <kurt@kwk.systems>  Tue, 19 May 2020 04:24:52 -0500

=== debian/control ===
Source: freecad
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Kuzminsky <seb@highlab.com>,
           Kurt Kremitzki <kkremitzki@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-exec,
               dh-python,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libcoin-dev,
               libdouble-conversion-dev,
               libglew-dev,
               liblz4-dev,
               libopencv-dev | libcv-dev,
               libeigen3-dev (>= 3.3~beta1),
               libgts-bin,
               libgts-dev,
               libkdtree++-dev,
               libmedc-dev,
               libmetis-dev,
               libocct-data-exchange-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libproj-dev,
               libpyside2-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5xmlpatterns5-dev,
               libqt5x11extras5-dev,
               libshiboken2-dev,
               libspnav-dev,
               libvtk7-dev,
               libx11-dev,
               libxerces-c-dev,
               libzipios++-dev,
               lsb-release,
               occt-draw,
               pybind11-dev,
               pyqt5-dev-tools,
               pyside2-tools,
               python3-dev,
               python3-matplotlib,
               python3-ply,
               python3-pyside2.qtcore,
               python3-pyside2.qtgui,
               python3-pyside2.qtsvg,
               python3-pyside2.qtuitools,
               python3-pyside2.qtwidgets,
               python3-pyside2.qtxml,
               python3-requests,
               qtbase5-dev,
               qttools5-dev,
               swig,
Build-Depends-Indep: doxygen
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/freecad
Vcs-Git: https://salsa.debian.org/science-team/freecad.git
Homepage: https://freecadweb.org/

Package: freecad
Architecture: all
Depends: freecad-python3,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: calculix-ccx,
            graphviz
Suggests: povray
Breaks: freecad (<< 0.18)
Replaces: freecad (<< 0.18)
Description: Extensible Open Source CAx program
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This is a metapackage of FreeCAD component packages.

Package: freecad-python3
Architecture: any
Depends: freecad-common,
         python3-matplotlib,
         python3-pivy,
         python3-ply,
         python3-pyside2.qtcore,
         python3-pyside2.qtgui,
         python3-pyside2.qtuitools,
         python3-pyside2.qtsvg,
         python3-pyside2.qtwidgets,
         python3-pyside2.qtxml,
         python3-yaml,
         libfreecad-python3-0.19 (<< ${binary:Version}+1~),
         libfreecad-python3-0.19 (>= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks: libfreecad-python2-0.17
Replaces: libfreecad-python2-0.17
Description: Extensible Open Source CAx program - Python 3 binaries
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains the FreeCAD binaries built against Python 3.

Package: freecad-common
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: freecad (<< 0.18), freecad-python2 (<< 0.18), freecad-runtime (<< 0.19)
Replaces: freecad (<< 0.18), freecad-python2 (<< 0.18), freecad-runtime (<< 0.19)
Description: Extensible Open Source CAx program - common files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains FreeCAD common files and resources.

Package: libfreecad-python3-0.19
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libfreecad-python3-0.18
Replaces: libfreecad-python3-0.18
Description: Extensible Open Source CAx program - Python 3 library files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains shared library files for FreeCAD built against Python 3.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake --with python3

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,+bindnow

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS) -Wall -fpermissive
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) -I/usr/include/python$(shell py3versions -d -v)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

py3ver = $(shell py3versions -d -v | tr -d .)
ifeq (1,$(shell expr ${py3ver} \< 38 ))
    py3ver := $(py3ver)m
endif

extra_flags += \
-DBUILD_QT5=ON \
-DBUILD_FLAT_MESH=ON \
-DFREECAD_BUILD_DEBIAN=ON \
-DFREECAD_USE_PYBIND11=ON \
-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
-DCMAKE_C_FLAGS="$(CFLAGS)" \
-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
-DLIB_SUFFIX="" \
-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-DCMAKE_INSTALL_DATADIR="/usr/share/freecad" \
-DCMAKE_INSTALL_DOCDIR="/usr/share/doc/freecad-doc" \
-DCMAKE_INSTALL_PREFIX="/usr/share/freecad" \
-DPYTHON_CONFIG_SUFFIX=".cpython-$(py3ver)-$(DEB_HOST_MULTIARCH)"

py3_flags = \
-DPYTHON_EXECUTABLE="/usr/bin/python3" \
-DCMAKE_INSTALL_LIBDIR="/usr/lib/freecad-python3/lib"

override_dh_auto_configure:
	dh_auto_configure --builddirectory=debian/build-py3 -- \
	    $(extra_flags) \
	    $(py3_flags)

override_dh_auto_build:
	dh_auto_build --builddirectory=debian/build-py3

override_dh_auto_test:
	dh_auto_test --builddirectory=debian/build-py3

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-py3
	mv debian/tmp/usr/share/freecad/bin/FreeCADCmd \
	    debian/tmp/usr/share/freecad/bin/FreeCADCmd-Python3
	mv debian/tmp/usr/share/freecad/bin/FreeCAD \
	    debian/tmp/usr/share/freecad/bin/FreeCAD-Python3

override_dh_compress:
	dh_compress -X.qch -X.qhc

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.txt

override_dh_installexamples:

override_dh_missing:
	dh_missing --list-missing
